# SBC-progress-tracking

## Purpose of this repo

I need a place to track the status and progress of the project to purchase, test, and support Single Board Computers for SIG/AltArch and Testing teams. This is the start of it.

# The SBC's

This list is per the poll vote of the Rocky Community. There are two additions that have been added because of rising interest after the poll. They are noted as such.

The Raspberry Pi 4's and 3's are supported by SIG/AltArch now. However, it would be good to ensure we meet the same requirements that we are placing on the other SBC's still knowing that RPi's are hard to get.

[Raspberry Pi 32bit (armhfp/armv7)](https://www.raspberrypi.com/documentation/computers/processors.html)  
[VisionFive 2 (RISC-V)](https://www.kickstarter.com/projects/starfive/visionfive-2)  
[ROCKPro64 (ARM64)](https://pine64.com/product/rockpro64-4gb-single-board-computer/)  
[Pine A64-LTS (ARM64)](https://pine64.com/product/pine-a64-lts/)  
[ODROID-N2+ (ARM64)](https://ameridroid.com/products/odroid-n2-plus)  
[Radxa ROCK 5 Model B (ARM64)](https://ameridroid.com/products/rock5-model-b)  
Add-on [Nvidia Jetson Nano (ARM64)](https://www.nvidia.com/en-us/autonomous-machines/embedded-systems/jetson-nano/education-projects/)  
Add-on [Libre.computer AML-S905X-CC (Le Potato) (ARM64)](https://libre.computer/products/aml-s905x-cc/)  

# Proposed plan of action (summary)

The granted proposal allows for $20,000 (US) for purchase and support of SBC's at an estimated rate of twenty purchases for six SBC devices. This is subject to change depending on the difficulty of adding support to the devices. Also, those requiring alternative unsupported architectures (32 bit ARM and RISC-V) are still in evaluation state.

The focus will be to get those insterested in being "Developers" in SIG/AltArch access to the SBC's then get those interested in being "Testers" in the Testing Team access. Finally, those interested in participating within the Rocky community assisting others with questions and problems will be given access to remaining SBC's (eg: "Community Engagement").

Those who are Rocky Members, or are being mentored with the goal of Rocky Membership, will be given priority access over those in the wider Rocky community. Exact details on how this will be done is still to be determined.

This document is to help Stack track which SBC and who is willing to perform one of the three roles:

Developers: Assist in building packages, images, and anything else needed.
Testers: Are available on release weeks to ensure images are functional and the SBC device is fully functional.
Community Engagement: Are willing to answer questions and assist in troubleshooting the questions from the larger general Rocky community.

# Raspberry Pi

https://www.raspberrypi.com/documentation/computers/processors.html  
https://www.raspberrypi.com/products/

## 64bit (RPi3 and RPi4)

Status: Supported by SIG/AltArch

| Developers | Testers                      | Community Engagement      |
| ---------- | ---------------------------- | ------------------------- |
| @codedude  | @Stack (already owns RPI4)   |                           |
| @sherif (already owns RPi4/RPi3/RPi0w/RPi0w2) | @lumarel (already owns RPi4) | @lumarel (interested)     |

## 32bit (Most RPi2's, RPI 0's, and older)

Status: ARMhfp (32bit) is mostly built; ongoing conversations to get dedicated hardware for building.

| Developers | Testers                          | Community Engagement      |
| ---------- | -------------------------------- | ------------------------- |
| @pgreco    | @Stack (already owns RPI2, RPI0) |                           |
| @label     | @lumarel (already owns RPi2)     | @lumarel (interested)     |
| @neil      | @codedude (already own RPI2)     |                           |
| @sherif (already owns RPi2)

# StarFive

## VisionFive2

VisionFive2 information: https://www.kickstarter.com/projects/starfive/visionfive-2  
VisionFive2 Github: https://github.com/starfive-tech/VisionFive2  
VisionFive2 official vendor list: https://forum.rvspace.org/t/how-to-purchase-visionfive-2/665  
Status:

| Developers | Testers                           | Community Engagement |
| ---------- | --------------------------------- | -------------------- |
| @codedude  | @Stack (already owns VisionFive2) |                      |
| @skip77    | @alangm                           |                      |
| @neil      |                                   |                      |
| @pgreco    |                                   |                      |
| @tgo       |                                   |                      |
| @mustafa   |                                   |                      |
| @alangm (interested) |                         |                      |
| @sherif (PbR) |                                |                      |

* PbR = Purchased by Rocky for support purposes by this initiative.

# Pine64

## ROCKPro 64

https://pine64.com/product/rockpro64-4gb-single-board-computer/  
Status: Completed by SIG/AltArch; ready for purchasing - waiting on Pine64

| Developers | Testers               | Community Engagement      |
| ---------- | --------------------- | ------------------------- |
| @sherif (already owns) | @lumarel (TbP) | @lumarel             |
| @skip77 (TbP) | @stack (TbP)       | @stack                    |
| @neil (TbP)|                       |                           |

* TbP - To be Purchased.

## A64_LTS

https://pine64.com/product/pine-a64-lts/  
Status: Ready for puchasing - waiting on Pine64

| Developers | Testers | Community Engagement |
| ---------- | ------- | -------------------- |
| @neil (TbP) | @stack (TbP) |                |
|            | @lumarel (TbP) |               |
|            | @anavarro10 (TbP) |            |

* TbP - To be Purchased.

# Ameridroid

## ODROID-N2+

https://ameridroid.com/products/odroid-n2-plus  
Status: Due to requiring special kernel modules - this is a future project when we have developers willing to build/maintain the modules.

| Developers | Testers             | Community Engagement |
| ---------- | ------------------- | -------------------- |
|            | @Stack (interested) |                      |

## Radxa ROCK 5 Model B

https://ameridroid.com/products/rock5-model-b  
Status: Due to requiring special kernel modules - this is a future project when we have developers willing to build/maintain the modules.

| Developers | Testers               | Community Engagement      |
| ---------- | --------------------- | ------------------------- |
|            | @Stack (interested)   |                           |
|            | @lumarel (interested) | (open for helping others) |

# NVidia

## Jetson Nano

https://www.nvidia.com/en-us/autonomous-machines/embedded-systems/jetson-nano/education-projects/  
Status: SBC's under investigation

| Developers | Testers             | Community Engagement |
| ---------- | ------------------- | -------------------- |
| @neil (PbR)| @Stack (PbR)        |                      |

* PbR = Purchased by Rocky for support purposes by this initiative.

# Libre.computer

## AML-S905X-CC (Le Potato)

https://libre.computer/products/aml-s905x-cc/  
Status: SBC's under investigation

| Developers | Testers | Community Engagement |
| ---------- | ------- | -------------------- |
| @neil (PbR)| @Stack (PbR) |                 |
| @skip (PbR)| @anavarro10 (PbR) |            |

* PbR = Purchased by Rocky for support purposes by this initiative.

## ALL-H3-CC (Tritium)

This is an added system from the original proposal
https://libre.computer/products/aml-s905x-cc/  
Status: SBC's under investigation

| Developers | Testers | Community Engagement |
| ---------- | ------- | -------------------- |
| @neil (PbR)| @Stack (PbR) |            |
|            | @anavarro10 (interested) |     |

* PbR = Purchased by Rocky for support purposes by this initiative.

## AML-S805X-AC (La Frite)

This is an added system from the original proposal
https://libre.computer/products/aml-s805x-ac/
Status: SBC's under investigation

| Developers | Testers | Community Engagement |
| ---------- | ------- | -------------------- |
| @neil (PbR)| @Stack (PbR) |            |
|            | @anavarro10 (interested) |     |

* PbR = Purchased by Rocky for support purposes by this initiative.

## ROC-RK3328-CC(Renegade)

This is an added system from the original proposal
https://libre.computer/products/roc-rk3328-cc/
Status: SBC's under investigation

| Developers | Testers | Community Engagement |
| ---------- | ------- | -------------------- |
| @neil (PbR)| @Stack (PbR) |            |
|            | @anavarro10 (interested) |     |

* PbR = Purchased by Rocky for support purposes by this initiative.

# PCEngines

This is an added system from the original proposal
## APU2

https://pcengines.ch/apu2.htm
Status:

| Developers | Testers | Community Engagement |
| ---------- | ------- | -------------------- |
| @sherif (already owns) |  |            |
| @neil (already owns) |  |            |

